# Changelog

## Unreleased

### Changes in benchmarking

Benchmarks can now run not only multiple seeds but also multiple models. For
example, here is a way to benchmark jobshop instances `ft6` and `ft10`, each on
10 different randoms seeds:

```sh
node jobshop.js --nbWorkers 1 data/ft6 data/ft10 --nbSeeds 10 --nbParallelRuns 5
```

In addition, using parameter `--outputFile`, the results can be saved in a JSON file.

### Added

* Many presolves. Most notably constant folding, presolve for linear expressions
  and detection of alternative cost* (used e.g. in multi-mode RCPSP).
* Multi-mode RCPSP benchmark.

### Changed

* LNS now works on a pool of solutions. Best solution receives most attention.
  The pool can be configured using parameters `LNSTier*`.

### Removed

* Many bugs, in presolve in particular.

### Fixed

### Deprecated

## v0.7.1 - 2022-08-22

### Added

* Log in developer mode now contains information about how each solution was found.
* Internal trace `FDSRatings`. It prints information from Failure-Directed Search
  in a CSV form suitable for further data processing. See more documentation in
  `Parameters.md` (in internal build).
* Lower bounds reporting. Includes log and JavaScript API.
* New parameter `SolutionLimit` (handled globally by Master).
* Scheduling of end times in case of interval variables with variable length.

### Changed

* Benchmark option `--runs` was renamed to `--benchmark`. In addition it now
  supports `n/k` parameter where `n` is number of runs and `k` specifies how
  many runs can be executed concurrently. By default `k` is 1.
* Renamed shortcuts to binary comparison operators to follow HTML entity names:
  * `lt` for `<`
  * `le` for `<=`
  * `gt` for `>`
  * `ge` for `>=`
  * `ne` for `!=`
  * `eq` for `==`

### Fixed

* LNS first solution was using `failLimit` 1 instead of `solutionLimit` 1.

## v0.7 - 2022-07-15

* Very first release
